package nl.amis.headtohead.view;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import java.util.Map;

import javax.faces.bean.ManagedBean;

import javax.faces.bean.RequestScoped;

import oracle.adf.model.BindingContext;

import oracle.adf.model.binding.DCBindingContainer;

import oracle.adf.model.binding.DCIteratorBinding;

import oracle.binding.BindingContainer;

import oracle.jbo.Row;

@ManagedBean
@RequestScoped
public class DepartmentJudge {
    private List<Map<String,String>> columns;
    private List<Map<String,Object>> rows;
    
    public DepartmentJudge() {
        prepareGrid();
    }
        
    private void prepareGrid() {
        columns = new ArrayList<Map<String,String>>();
        rows = new ArrayList<Map<String,Object>>();
        Map<String,String> column = new HashMap<String,String>();
        column.put("label", "Department");
        column.put("name", "header");
        columns.add(column);

        Map<String,Object> row = new HashMap<String,Object>();
        row.put("header", "Name");
        row.put("attribute", "Dname");
        rows.add(row);

        row = new HashMap<String,Object>();
        row.put("header", "Head Count");
        row.put("attribute", "Empcount");
        row.put("type", "bar");
        row.put("range", 10);
        row.put("base", 0);
        rows.add(row);

        row = new HashMap<String,Object>();
        row.put("header", "Location");
        row.put("attribute", "Loc");
        rows.add(row);

        row = new HashMap<String,Object>();
        row.put("header", "Average Salary");
        row.put("attribute", "Avgsal");
        row.put("type", "bar");
        row.put("range", 3500);
        row.put("base", 0);
        rows.add(row);


        row = new HashMap<String,Object>();
        row.put("header", "Average Experience");
        row.put("attribute", "Avgexp");
        row.put("type", "bar");
        row.put("range", 11000);
        row.put("base", 10500);
        rows.add(row);

        row = new HashMap<String,Object>();
        row.put("header", "Highest Salary");
        row.put("attribute", "Maxsal");
        row.put("type", "bar");
        row.put("range", 6000);
        row.put("base", 0);
        rows.add(row);
        
        BindingContext bcxt = BindingContext.getCurrent();
        DCBindingContainer bc = null;
        bc = (DCBindingContainer)bcxt.getCurrentBindingsEntry();
        DCIteratorBinding iter = bc.findIteratorBinding("DepartmentSummaryView1Iterator");


        Row[] depts = iter.getAllRowsInRange();
        for (Row dept:depts) {
            column = new HashMap<String,String>();
            column.put("label", ((Integer)dept.getAttribute("Deptno")).toString());
            column.put("name", ((Integer)dept.getAttribute("Deptno")).toString());
            
            
            columns.add(column);
            for (Map<String,Object> trow :rows) {
              trow.put(column.get("name"), dept.getAttribute((String)trow.get("attribute")));
            }

        }
        
        
    }
    
    public List<Map<String,String>> getColumns() {
        return columns;
        
    }

    public void setRows(List<Map<String, Object>> rows) {
        this.rows = rows;
    }

    public List<Map<String, Object>> getRows() {
        return rows;
    }
}
